# coding: utf-8

"""
    VMware Aria Automation Assembler / CMX Service API

    When using Kubernetes integration, deploy and manage Kubernetes clusters and namespaces. The APIs that list collections of resources also support OData like implementation. Below query params can be used across CMX entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/cmx/api/resources/tags?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/cmx/api/resources/tags?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/cmx/api/resources/tags?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /cmx/api/resources/tags?$filter=startswith(name, 'K8S')   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Cmxapiresourcesk8sclustersCredentials(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'bearer': 'bool',
        'custom_properties': 'dict(str, str)',
        'document_self_link': 'str',
        'password': 'bool',
        'private_key': 'str',
        'private_key_id': 'str',
        'public_key': 'str',
        'tenant_links': 'list[str]',
        'type': 'str',
        'user_email': 'str'
    }

    attribute_map = {
        'bearer': 'bearer',
        'custom_properties': 'customProperties',
        'document_self_link': 'documentSelfLink',
        'password': 'password',
        'private_key': 'privateKey',
        'private_key_id': 'privateKeyId',
        'public_key': 'publicKey',
        'tenant_links': 'tenantLinks',
        'type': 'type',
        'user_email': 'userEmail'
    }

    def __init__(self, bearer=None, custom_properties=None, document_self_link=None, password=None, private_key=None, private_key_id=None, public_key=None, tenant_links=None, type=None, user_email=None):  # noqa: E501
        """Cmxapiresourcesk8sclustersCredentials - a model defined in Swagger"""  # noqa: E501
        self._bearer = None
        self._custom_properties = None
        self._document_self_link = None
        self._password = None
        self._private_key = None
        self._private_key_id = None
        self._public_key = None
        self._tenant_links = None
        self._type = None
        self._user_email = None
        self.discriminator = None
        if bearer is not None:
            self.bearer = bearer
        if custom_properties is not None:
            self.custom_properties = custom_properties
        if document_self_link is not None:
            self.document_self_link = document_self_link
        if password is not None:
            self.password = password
        if private_key is not None:
            self.private_key = private_key
        if private_key_id is not None:
            self.private_key_id = private_key_id
        if public_key is not None:
            self.public_key = public_key
        if tenant_links is not None:
            self.tenant_links = tenant_links
        if type is not None:
            self.type = type
        if user_email is not None:
            self.user_email = user_email

    @property
    def bearer(self):
        """Gets the bearer of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501


        :return: The bearer of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :rtype: bool
        """
        return self._bearer

    @bearer.setter
    def bearer(self, bearer):
        """Sets the bearer of this Cmxapiresourcesk8sclustersCredentials.


        :param bearer: The bearer of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :type: bool
        """

        self._bearer = bearer

    @property
    def custom_properties(self):
        """Gets the custom_properties of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501


        :return: The custom_properties of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_properties

    @custom_properties.setter
    def custom_properties(self, custom_properties):
        """Sets the custom_properties of this Cmxapiresourcesk8sclustersCredentials.


        :param custom_properties: The custom_properties of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :type: dict(str, str)
        """

        self._custom_properties = custom_properties

    @property
    def document_self_link(self):
        """Gets the document_self_link of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501


        :return: The document_self_link of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :rtype: str
        """
        return self._document_self_link

    @document_self_link.setter
    def document_self_link(self, document_self_link):
        """Sets the document_self_link of this Cmxapiresourcesk8sclustersCredentials.


        :param document_self_link: The document_self_link of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :type: str
        """

        self._document_self_link = document_self_link

    @property
    def password(self):
        """Gets the password of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501


        :return: The password of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :rtype: bool
        """
        return self._password

    @password.setter
    def password(self, password):
        """Sets the password of this Cmxapiresourcesk8sclustersCredentials.


        :param password: The password of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :type: bool
        """

        self._password = password

    @property
    def private_key(self):
        """Gets the private_key of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501


        :return: The private_key of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :rtype: str
        """
        return self._private_key

    @private_key.setter
    def private_key(self, private_key):
        """Sets the private_key of this Cmxapiresourcesk8sclustersCredentials.


        :param private_key: The private_key of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :type: str
        """

        self._private_key = private_key

    @property
    def private_key_id(self):
        """Gets the private_key_id of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501


        :return: The private_key_id of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :rtype: str
        """
        return self._private_key_id

    @private_key_id.setter
    def private_key_id(self, private_key_id):
        """Sets the private_key_id of this Cmxapiresourcesk8sclustersCredentials.


        :param private_key_id: The private_key_id of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :type: str
        """

        self._private_key_id = private_key_id

    @property
    def public_key(self):
        """Gets the public_key of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501


        :return: The public_key of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :rtype: str
        """
        return self._public_key

    @public_key.setter
    def public_key(self, public_key):
        """Sets the public_key of this Cmxapiresourcesk8sclustersCredentials.


        :param public_key: The public_key of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :type: str
        """

        self._public_key = public_key

    @property
    def tenant_links(self):
        """Gets the tenant_links of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501


        :return: The tenant_links of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :rtype: list[str]
        """
        return self._tenant_links

    @tenant_links.setter
    def tenant_links(self, tenant_links):
        """Sets the tenant_links of this Cmxapiresourcesk8sclustersCredentials.


        :param tenant_links: The tenant_links of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :type: list[str]
        """

        self._tenant_links = tenant_links

    @property
    def type(self):
        """Gets the type of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501


        :return: The type of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Cmxapiresourcesk8sclustersCredentials.


        :param type: The type of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def user_email(self):
        """Gets the user_email of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501


        :return: The user_email of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :rtype: str
        """
        return self._user_email

    @user_email.setter
    def user_email(self, user_email):
        """Sets the user_email of this Cmxapiresourcesk8sclustersCredentials.


        :param user_email: The user_email of this Cmxapiresourcesk8sclustersCredentials.  # noqa: E501
        :type: str
        """

        self._user_email = user_email

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Cmxapiresourcesk8sclustersCredentials, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Cmxapiresourcesk8sclustersCredentials):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
